Class for building pages

All methods are chainable, with the exception of the constructor, build_header(), build_footer(), and _headers() methods.

package | miniMVC
subpackage | System

### Methods

## Allow calling of array methods on the object and dynamic methods

    __call(string $name, array $params) : mixed

Inherited

inherited_from | \MM::__call()

### Parameters

#### $name

`string`

#### $params

`array`

### Returns

`mixed`

## Set up the page class

    __construct($controller) : void

### Parameters

#### $controller

``

object

## append()

    append()

Inherited

inherited_from | ArrayObject::append()
inherited_from | \MM::append()

## asort()

    asort()

Inherited

inherited_from | ArrayObject::asort()
inherited_from | \MM::asort()

## Sets custom page header

    build_header(bool $html5) : \Page

### Parameters

#### $html5

`bool`

### Returns

`\Page`

## count()

    count()

Inherited

inherited_from | ArrayObject::count()
inherited_from | \MM::count()

## exchangeArray()

    exchangeArray()

Inherited

inherited_from | ArrayObject::exchangeArray()
inherited_from | \MM::exchangeArray()

## getArrayCopy()

    getArrayCopy()

Inherited

inherited_from | ArrayObject::getArrayCopy()
inherited_from | \MM::getArrayCopy()

## getFlags()

    getFlags()

Inherited

inherited_from | ArrayObject::getFlags()
inherited_from | \MM::getFlags()

## getIterator()

    getIterator()

Inherited

inherited_from | ArrayObject::getIterator()
inherited_from | \MM::getIterator()

## getIteratorClass()

    getIteratorClass()

Inherited

inherited_from | ArrayObject::getIteratorClass()
inherited_from | \MM::getIteratorClass()

## ksort()

    ksort()

Inherited

inherited_from | ArrayObject::ksort()
inherited_from | \MM::ksort()

## natcasesort()

    natcasesort()

Inherited

inherited_from | ArrayObject::natcasesort()
inherited_from | \MM::natcasesort()

## natsort()

    natsort()

Inherited

inherited_from | ArrayObject::natsort()
inherited_from | \MM::natsort()

## offsetExists()

    offsetExists()

Inherited

inherited_from | ArrayObject::offsetExists()
inherited_from | \MM::offsetExists()

## offsetGet()

    offsetGet()

Inherited

inherited_from | ArrayObject::offsetGet()
inherited_from | \MM::offsetGet()

## offsetSet()

    offsetSet()

Inherited

inherited_from | ArrayObject::offsetSet()
inherited_from | \MM::offsetSet()

## offsetUnset()

    offsetUnset()

Inherited

inherited_from | ArrayObject::offsetUnset()
inherited_from | \MM::offsetUnset()

## Output String

    output_string(string $string)

Similar to render(), this is a shortcut to output a string in the body of the page.

### Parameters

#### $string

`string`

## Redirect 303

    redirect_303(string $url)

Shortcut function for 303 redirect

### Parameters

#### $url

`string`

## Render

    render(string $view, array $data)

Shortcut function for building a page

### Parameters

#### $view

`string`

#### $data

`array`

## serialize()

    serialize()

Inherited

inherited_from | ArrayObject::serialize()
inherited_from | \MM::serialize()

## setFlags()

    setFlags()

Inherited

inherited_from | ArrayObject::setFlags()
inherited_from | \MM::setFlags()

## setIteratorClass()

    setIteratorClass()

Inherited

inherited_from | ArrayObject::setIteratorClass()
inherited_from | \MM::setIteratorClass()

## Sets custom base href

    set_base(string $href) : \Page

### Parameters

#### $href

`string`

href

### Returns

`\Page`

## Sets custom body class

    set_body_class(string $class) : \Page

### Parameters

#### $class

`string`

### Returns

`\Page`

## Sets custom body id

    set_body_id(string $id) : \Page

### Parameters

#### $id

`string`

### Returns

`\Page`

## Sets a minified css group

    set_css_group(string $group) : \Page

### Parameters

#### $group

`string`

### Returns

`\Page`

## Sets custom css tags

    set_css_tag(string $name, bool $domain, string $media) : \Page

### Parameters

#### $name

`string`

#### $domain

`bool`

#### $media

`string`

### Returns

`\Page`

## Sets a minified javascript group for the page footer

    set_foot_js_group(string $group, bool $debug) : \Page

### Parameters

#### $group

`string`

#### $debug

`bool`

### Returns

`\Page`

## Sets minified javascript group in header

    set_head_js_group(string $group, bool $debug) : \Page

### Parameters

#### $group

`string`

#### $debug

`bool`

### Returns

`\Page`

## Sets a custom tag in the header

    set_head_tag(string $tag) : \Page

### Parameters

#### $tag

`string`

### Returns

`\Page`

## Set Message

    set_message(string $type, string $message, bool $return) : void

Adds a message to the page

### Parameters

#### $type

`string`

#### $message

`string`

#### $return

`bool`

## Set Meta

    set_meta(array $meta) : \Page

Sets meta tags, with codeigniter native meta tag helper

### Parameters

#### $meta

`array`

### Returns

`\Page`

## Sets html title string

    set_title(string $title) : \Page

### Parameters

#### $title

`string`

### Returns

`\Page`

## uasort()

    uasort()

Inherited

inherited_from | ArrayObject::uasort()
inherited_from | \MM::uasort()

## uksort()

    uksort()

Inherited

inherited_from | ArrayObject::uksort()
inherited_from | \MM::uksort()

## unserialize()

    unserialize()

Inherited

inherited_from | ArrayObject::unserialize()
inherited_from | \MM::unserialize()

## Sets server headers and doctype

    _headers(bool $html5) : \Page

Also sets page mime type, based on if sent as html or xhtml, and what the target browser supports

### Parameters

#### $html5

`bool`

### Returns

`\Page`

## Private helper function to generate link tags

    _link_tag(array $params) : string

### Parameters

#### $params

`array`

### Returns

`string`

## Private helper function to generate meta tags

    _meta(array $params) : string

### Parameters

#### $params

`array`

### Returns

`string`

## Script Tag

    script_tag(string $js, bool $domain) : string

Helper function for making script tags

### Parameters

#### $js

`string`

#### $domain

`bool`

### Returns

`string`

### Properties

## Base tag

    $base : string

## Class(es) to apply to the main body tag

    $body_class : string

## Id to apply to the body tag

    $body_id : string

## CSS tags for the page

    $css : string

## JS tags for the footer

    $foot_js : string

## JS tags for the header

    $head_js : string

## Additional header tags

    $head_tags : string

## Meta tags

    $meta : string

## Page title

    $title : string